using System;

namespace HeuristicLab.Problems.GrammaticalOptimization {
  public class ReadonlySequence : Sequence {
    public ReadonlySequence(string s)
      : base(s) {
    }

    public ReadonlySequence(char ch)
      : base(ch) {
    }

    public ReadonlySequence(Sequence s)
      : base(s) {
    }

    public override void ReplaceAt(int position, int len, Sequence replacement) {
      throw new NotSupportedException();
    }

    public override bool Equals(object obj) {
      var other = obj as Sequence;
      if (other == null) return false;
      if (other.Length != this.Length) return false;
      for (int i = 0; i < Length; i++)
        if (other[i] != this[i]) return false;

      // length and all symbols are the same
      return true;
    }

    public override int GetHashCode() {
      int h = 31 * Length;
      foreach (var ch in this) { h += 31 * (byte)h; }
      return h;
    }
  }
}